package org.jeecg.modules.stm.wb.survey.controller;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;
import jakarta.servlet.http.HttpServletRequest;
import jakarta.servlet.http.HttpServletResponse;
import org.jeecg.common.api.vo.Result;
import org.jeecg.common.system.query.QueryGenerator;
import org.jeecg.modules.stm.wb.survey.entity.WbKeyName;
import org.jeecg.modules.stm.wb.survey.entity.WbSurveyCfg;
import org.jeecg.modules.stm.wb.survey.service.IWbKeyNameService;
import org.jeecg.modules.stm.wb.survey.service.IWbSurveyCfgService;
import org.jeecg.modules.stm.wb.manage.entity.WbCompanyThirdApi;
import org.jeecg.modules.stm.wb.manage.service.IWbCompanyThirdApiService;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import lombok.extern.slf4j.Slf4j;

import org.jeecg.common.system.base.controller.JeecgController;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.servlet.ModelAndView;
 
 
import org.jeecg.common.aspect.annotation.AutoLog;
import org.apache.shiro.authz.annotation.RequiresPermissions;

 /**
 * @Description: 调查配置
 * @Author: jeecg-boot
 * @Date:   2024-03-14
 * @Version: V1.0
 */

@RestController
@RequestMapping("/wb.survey/wbSurveyCfg")
@Slf4j
public class WbSurveyCfgController extends JeecgController<WbSurveyCfg, IWbSurveyCfgService> {
	@Autowired
	private IWbSurveyCfgService wbSurveyCfgService;
	@Autowired
	private IWbKeyNameService wbKeyNameService;
	 @Autowired
	 private IWbCompanyThirdApiService wbCompanyThirdApiService;
	
	/**
	 * 分页列表查询
	 *
	 * @param wbSurveyCfg
	 * @param pageNo
	 * @param pageSize
	 * @param req
	 * @return
	 */
	//@AutoLog(value = "调查配置-分页列表查询")

	@GetMapping(value = "/list")
	public Result<IPage<WbSurveyCfg>> queryPageList(WbSurveyCfg wbSurveyCfg,
								   @RequestParam(name="pageNo", defaultValue="1") Integer pageNo,
								   @RequestParam(name="pageSize", defaultValue="10") Integer pageSize,
								   HttpServletRequest req) {
		QueryWrapper<WbSurveyCfg> queryWrapper = QueryGenerator.initQueryWrapper(wbSurveyCfg, req.getParameterMap());
		Page<WbSurveyCfg> page = new Page<WbSurveyCfg>(pageNo, pageSize);
		IPage<WbSurveyCfg> pageList = wbSurveyCfgService.page(page, queryWrapper);
		return Result.OK(pageList);
	}
	
	/**
	 *   添加
	 *
	 * @param wbSurveyCfg
	 * @return
	 */
	@AutoLog(value = "调查配置-添加")

	@RequiresPermissions("wb.survey:wb_survey_cfg:add")
	@PostMapping(value = "/add")
	public Result<String> add(@RequestBody WbSurveyCfg wbSurveyCfg) {
		wbSurveyCfgService.save(wbSurveyCfg);
		return Result.OK("添加成功！");
	}

	 @AutoLog(value = "调查配置-添加")

	 @RequiresPermissions("wb.survey:wb_survey_cfg:add")
	 @PostMapping(value = "/addBatch")
	 public Result<String> addBatch(@RequestBody WbSurveyCfg wbSurveyCfg) {
		String wkeys = wbSurveyCfg.getAttrKey();
		if(wkeys==null || wkeys.equals("")){
		return Result.error("缺失参数");
		}
		Integer tp = wbSurveyCfg.getTp();
		List<String> listKey = Arrays.asList(wkeys.split(","));
		List<WbSurveyCfg> saveList = new ArrayList<>();
		if(tp==3) {
			 QueryWrapper<WbKeyName> queryWrapper = new QueryWrapper<>();
			 queryWrapper.in("wkey", listKey);
			 List<WbKeyName> listKeyName = wbKeyNameService.list(queryWrapper);
			 for (WbKeyName wbKeyName : listKeyName) {
				 WbSurveyCfg wsCfg = new WbSurveyCfg();
				 wsCfg.setAttrKey(wbKeyName.getWkey());
				 wsCfg.setApiId(wbKeyName.getApiId());
				 wsCfg.setTp(tp);
				 wsCfg.setAttrName(wbKeyName.getWname());
				 wsCfg.setCollMethod(wbSurveyCfg.getCollMethod());
				 wsCfg.setDomainCode(wbSurveyCfg.getDomainCode());
				 wsCfg.setDomainName(wbSurveyCfg.getDomainName());
				 saveList.add(wsCfg);
			 }
			 wbSurveyCfgService.saveBatch(saveList);
		 } else if(tp==2) {
			 QueryWrapper<WbCompanyThirdApi> queryWrapper = new QueryWrapper<>();
			 queryWrapper.in("api_id", listKey);
			 List<WbCompanyThirdApi> listThirdApi = wbCompanyThirdApiService.list(queryWrapper);
			 for(WbCompanyThirdApi wbApi : listThirdApi){
				 WbSurveyCfg wsCfg = new WbSurveyCfg();
				 wsCfg.setApiId(wbApi.getApiId());
				 wsCfg.setTp(tp);
				 wsCfg.setAttrName(wbApi.getName());
				 wsCfg.setCollMethod(wbSurveyCfg.getCollMethod());
				 wsCfg.setDomainCode(wbSurveyCfg.getDomainCode());
				 wsCfg.setDomainName(wbSurveyCfg.getDomainName());
				 saveList.add(wsCfg);
			 }
			wbSurveyCfgService.saveBatch(saveList);
		 }

		 return Result.OK("添加成功！");
	 }
	
	/**
	 *  编辑
	 *
	 * @param wbSurveyCfg
	 * @return
	 */
	@AutoLog(value = "调查配置-编辑")

	@RequiresPermissions("wb.survey:wb_survey_cfg:edit")
	@RequestMapping(value = "/edit", method = {RequestMethod.PUT,RequestMethod.POST})
	public Result<String> edit(@RequestBody WbSurveyCfg wbSurveyCfg) {
		wbSurveyCfgService.updateById(wbSurveyCfg);
		return Result.OK("编辑成功!");
	}
	
	/**
	 *   通过id删除
	 *
	 * @param id
	 * @return
	 */
	@AutoLog(value = "调查配置-通过id删除")

	@RequiresPermissions("wb.survey:wb_survey_cfg:delete")
	@DeleteMapping(value = "/delete")
	public Result<String> delete(@RequestParam(name="id",required=true) String id) {
		wbSurveyCfgService.removeById(id);
		return Result.OK("删除成功!");
	}
	
	/**
	 *  批量删除
	 *
	 * @param ids
	 * @return
	 */
	@AutoLog(value = "调查配置-批量删除")

	@RequiresPermissions("wb.survey:wb_survey_cfg:deleteBatch")
	@DeleteMapping(value = "/deleteBatch")
	public Result<String> deleteBatch(@RequestParam(name="ids",required=true) String ids) {
		this.wbSurveyCfgService.removeByIds(Arrays.asList(ids.split(",")));
		return Result.OK("批量删除成功!");
	}
	
	/**
	 * 通过id查询
	 *
	 * @param id
	 * @return
	 */
	//@AutoLog(value = "调查配置-通过id查询")

	@GetMapping(value = "/queryById")
	public Result<WbSurveyCfg> queryById(@RequestParam(name="id",required=true) String id) {
		WbSurveyCfg wbSurveyCfg = wbSurveyCfgService.getById(id);
		if(wbSurveyCfg==null) {
			return Result.error("未找到对应数据");
		}
		return Result.OK(wbSurveyCfg);
	}

    /**
    * 导出excel
    *
    * @param request
    * @param wbSurveyCfg
    */
    @RequiresPermissions("wb.survey:wb_survey_cfg:exportXls")
    @RequestMapping(value = "/exportXls")
    public ModelAndView exportXls(HttpServletRequest request, WbSurveyCfg wbSurveyCfg) {
        return super.exportXls(request, wbSurveyCfg, WbSurveyCfg.class, "调查配置");
    }

    /**
      * 通过excel导入数据
    *
    * @param request
    * @param response
    * @return
    */
    @RequiresPermissions("wb.survey:wb_survey_cfg:importExcel")
    @RequestMapping(value = "/importExcel", method = RequestMethod.POST)
    public Result<?> importExcel(HttpServletRequest request, HttpServletResponse response) {
        return super.importExcel(request, response, WbSurveyCfg.class);
    }

	 @GetMapping(value = "/queryAllByCode")
	 public Result<List<WbSurveyCfg>> queryAllByCode(@RequestParam(name="code",required=true) String code) {
		 QueryWrapper<WbSurveyCfg> queryWrapper = new QueryWrapper<>();
		 queryWrapper.likeRight("domain_code",code);
		 List<WbSurveyCfg> wbSurveyCfgList = wbSurveyCfgService.list(queryWrapper);
		 if(wbSurveyCfgList==null) {
			 return Result.error("未找到对应数据");
		 }
		 return Result.OK(wbSurveyCfgList);
	 }

 }
